"use strict";

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

Object.defineProperty(exports, "__esModule", {
  value: true
});

var StoreAdapter =
/*#__PURE__*/
function () {
  function StoreAdapter(odux, name) {
    _classCallCheck(this, StoreAdapter);

    this.odux = odux;
    this.name = name;
    this.storeKey = odux.registerStorePath(this.storePath);
  }

  _createClass(StoreAdapter, [{
    key: "setAliasName",

    /** 设置Store别名 */
    value: function setAliasName(value) {
      this.name = value;
      this.storeKey = this.odux.registerStorePath(this.storePath, this.storeKey);
    }
    /** 设置Store在ReduxStore上路径前缀 */

  }, {
    key: "setPrefix",
    value: function setPrefix(value) {
      this.prefix = value;
      this.storeKey = this.odux.registerStorePath(this.storePath, this.storeKey);
    }
    /** 获取Store数据 */

  }, {
    key: "getData",
    value: function getData() {
      return this.odux.getStoreData(this.storeKey);
    }
    /** 批量跟踪 */

  }, {
    key: "transactionChange",
    value: function transactionChange(func, err) {
      var adapter = this;
      return function () {
        var _this = this,
            _arguments = arguments;

        return adapter.odux.transactionChange(adapter.storeKey, function () {
          return func.apply(_this, _arguments);
        }, err);
      };
    }
    /** apply change immediately */

  }, {
    key: "applyChange",
    value: function applyChange() {
      this.odux.applyChange([this.storeKey]);
    }
  }, {
    key: "StoreKey",
    get: function get() {
      return this.storeKey;
    }
  }, {
    key: "storePath",
    get: function get() {
      return [].concat(this.prefix || []).concat(this.name).filter(function (s) {
        return s;
      });
    }
  }]);

  return StoreAdapter;
}();

exports.StoreAdapter = StoreAdapter;