import { BaseEvent } from './BaseEvent';
import { ClassType } from 'power-di';
export declare class StoreChangeEvent extends BaseEvent<{
    storeKey?: string;
    value: any;
}[]> {
}
export declare class EventBus {
    private eventHandlers;
    private componentListeners;
    setStoreListener(cId: string, listener?: (evt: StoreChangeEvent) => void, storeKeys?: string[]): string;
    emitStoreChangeEvent(evt: StoreChangeEvent): void;
    /**
     * addEventListener
     * @param eventType typeof BaseEvent
     * @param callback event callback
     */
    addListener<T extends ClassType>(eventType: T, callback: (event: InstanceType<T>) => void): void;
    /**
     * removeEventListener
     * @param eventType typeof BaseEvent
     * @param callback event callback
     */
    removeListener<T extends ClassType>(eventType: T, callback: (event: InstanceType<T>) => void): void;
    removeAllListeners<T extends BaseEvent>(eventType: T): void;
    emit<T extends BaseEvent>(event: T): void;
    private getEventType;
}
