"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

Object.defineProperty(exports, "__esModule", {
  value: true
});

var React = require("react");

var PropTypes = require("prop-types");

var hoistStatics = require("hoist-non-react-statics");

var power_di_1 = require("power-di");

var utils_1 = require("power-di/utils");

var event_1 = require("../event");

var utils_2 = require("../utils");

var helper_1 = require("./helper");

var core_1 = require("../core");

var BaseStore_1 = require("../core/BaseStore");

var ConnectMetaSymbol = Symbol('ConnectMetaSymbol');

function getConnects(Type) {
  var connect = helper_1.getMetadata(Type).connect;
  var superType = Object.getPrototypeOf(Type);

  if (superType) {
    return Object.assign({}, getConnects(superType), connect);
  }

  return connect || {};
}

function connect(mapper) {
  return function (WrappedComponent) {
    var _a, _b;

    var storeKeys = [];

    var propsMapper = function propsMapper(state, ownProps, ioc) {
      var mapperProps = {};

      if (mapper) {
        mapperProps = mapper(state, ownProps, ioc) || {};
      }

      var bindData = {};
      var connect = getConnects(WrappedComponent);

      for (var key in connect) {
        var data = bindData[key] = connect[key](ioc); // TODO 支持计算表达式解析store

        if (storeKeys) {
          if (data instanceof core_1.BaseStore) {
            storeKeys.push(BaseStore_1.getStoreMeta(data).adapter.StoreKey);
          } else {
            storeKeys = undefined;
          }
        }
      }

      return Object.assign({}, ownProps || {}, mapperProps, _defineProperty({}, helper_1.PropsKeySymbol, bindData));
    };

    var Connect = (_b =
    /*#__PURE__*/
    function (_React$Component) {
      _inherits(_b, _React$Component);

      function _b(props, context) {
        var _this;

        _classCallCheck(this, _b);

        _this = _possibleConstructorReturn(this, _getPrototypeOf(_b).call(this, props, context));
        _this[_a] = {
          needUpdate: true,
          onStoreChange: function onStoreChange(evt) {
            _this.checkStateChange();
          }
        };
        var meta = _this[ConnectMetaSymbol];
        meta.ioc = context && context.iocContext || power_di_1.IocContext.DefaultInstance;
        meta.odux = meta.ioc.get(core_1.Odux);

        if (!meta.odux) {
          console.warn("NOTFOUND odux at iocContext (or default instance of ioc), will auto create one with 'new Odux();' on ioc.");
          meta.odux = new core_1.Odux({
            iocContext: meta.ioc
          });
        }

        meta.eventBus = meta.ioc.get(event_1.EventBus);
        var store = meta.odux.getReduxStore();
        _this.state = {
          data: propsMapper(store && store.getState(), props, meta.ioc)
        };
        return _this;
      }

      _createClass(_b, [{
        key: "componentDidMount",
        value: function componentDidMount() {
          this[ConnectMetaSymbol].cId = this[ConnectMetaSymbol].eventBus.setStoreListener(undefined, this[ConnectMetaSymbol].onStoreChange, storeKeys);
        }
      }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
          this[ConnectMetaSymbol].eventBus.setStoreListener(this[ConnectMetaSymbol].cId);
        }
      }, {
        key: "componentWillReceiveProps",
        value: function componentWillReceiveProps(nextProps, nextContext) {
          this.checkStateChange(nextProps);
        }
      }, {
        key: "shouldComponentUpdate",
        value: function shouldComponentUpdate(nextProps, nextState, nextContext) {
          return this[ConnectMetaSymbol].needUpdate;
        }
      }, {
        key: "checkStateChange",
        value: function checkStateChange() {
          var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.props;
          var meta = this[ConnectMetaSymbol];
          var store = meta.odux.getReduxStore();
          var newState = propsMapper(store && store.getState(), props, meta.ioc);
          meta.needUpdate = !utils_2.shallowEqual(this.state.data, newState);

          if (meta.needUpdate) {
            this.setState({
              data: newState
            });
          }
        }
      }, {
        key: "render",
        value: function render() {
          var props = this.props;
          var store = this[ConnectMetaSymbol].odux.getReduxStore();
          return React.createElement(WrappedComponent, Object.assign({
            dispatch: store && store.dispatch
          }, props, this.state.data));
        }
      }]);

      return _b;
    }(React.Component), _a = ConnectMetaSymbol, _b.contextTypes = {
      iocContext: PropTypes.any
    }, _b);
    var wrappedComponentName = WrappedComponent.displayName || WrappedComponent.name || utils_1.getGlobalType(WrappedComponent) || 'Component';
    Connect.displayName = "Odux(".concat(wrappedComponentName, ")");
    return hoistStatics(Connect, WrappedComponent);
  };
}

exports.connect = connect;